function [c, v] = counts_unique(x)
%[c,v]=counts_unique(x) - counts the occurences of each element of x
% 
% Required arguments:
%    x = matrix (any size)
%
% Return Values:
%    c = column vector for which c(i) = # of occurrences of v(i) in x
%    v = a sorted list of unique values in x
%
% Author: David Ross

error(nargchk(1,1,nargin));

x = x(:);

v = unique(x);

c = zeros(length(v),1);
for ii = 1:length(v)
    c(ii) = sum(x == v(ii));
end
