function p = impurity(clusters, classes)
% p = impurity(clusters, classes)
%   The average entropy (scaled from 0 to 1) of the clusters
%
% Author: David Ross, Sept. 13, 2003.

% the total number of clusters
num_clusters = length(clusters);

% the total number of classes
num_classes = length(unique(classes));

e = zeros(num_clusters,1);
for cc = 1:num_clusters
    current_probs = counts_unique(classes(clusters{cc}));
    current_probs = current_probs / length(clusters{cc});
    e(cc) = entropy(current_probs);
end

p = mean(e)/log(num_classes);


%//////////////////////////////////
function e = entropy(p)
e = - sum(p .* log(p+(p==0)));