% test_coil.m
% Author: David Ross, July 14, 2003.

% select_ids = [2 7 11]; % blocks
% select_ids = [3 6 19]; % cars
 select_ids = 1:5; % some objects

%----------------------------------------------------------
% Load the data
%----------------------------------------------------------
load('coil20_32x32.mat');
data = reshape(data,[size(data,1)*size(data,2) size(data,3)]);
data = double(data);

% choose only the blocks
blocks = zeros(size(id));
for ii = select_ids
    blocks = blocks | (id==ii);
end
blocks = find(blocks);
data = data(:,blocks);
id = id(blocks);

% map the ids as follows 3=>1, 6=>2, 19=>3
for ii = 1:length(select_ids)
    id(find(id==select_ids(ii))) = ii;
end

% D=dimensionality of data, N=number of data, C=number of classes
[D N] = size(data);
C = max(id(:));


%----------------------------------------------------------
% Run the experiment.
%----------------------------------------------------------

works = will_agglomerative_work(data,id);
disp(sprintf('will agglomerative clustering work? %d', works));
labels = agglomerative_cluster(data,length(select_ids),'complete',id);

for ii = unique(labels)'
    figure;
    plot_data(data(:,find(labels==ii)));
end


% objects 1:5
% perfectly correct up to 6 clusters, fails on creating 5th cluster because
% images 126 and 260 (block and cat) are less distant than images
% 302 and 303 (anacin).  The higher error comes from the fact that the
% Anacin box is highly textured with black and white, and when it is
% shifted slightly, the resulting grey-value at each pixel is very
% different.
%
% Failure mode for simple linkage agglomerative clustering: one rogue
% point placed between two clusters.